// Kahendpuul põhinev map oma O(log(n)) pöördumisajaga jääb suurtes testides
// ajahätta, paisktabelil põhinev unordered_map oma O(1) ajaga saab hakkama.

#include <fstream>
#include <vector>
#include <unordered_map>
using namespace std;

ifstream sis("ehesis.txt");
ofstream val("eheval.txt");

int n, m, k;
vector<int> a; // colors
vector<int> p; // parents
vector<unordered_map<int, int>> c; // counts of child colors
int b; // beauty of current configuration

int main() {
	sis >> n >> m >> k;
	a.resize(1 + n);
	for (int i = 1; i <= n; ++i) {
		sis >> a[i];
	}
	p.resize(1 + n);
	p[2] = 1; // lamp 1 is parent of lamp 2
	for (int i = 3; i <= n; ++i) {
		sis >> p[i]; // parent of i
	}
	c.resize(1 + n);
	for (int i = 2; i <= n; ++i) {
		c[p[i]][a[i]]++; // p[i] has one more child of color of a[i]
	}
	// initial beauty
	b = 0;
	for (int i = 1; i <= n; ++i) {
		b += (a[i] == a[p[i]]);
	}
	// process changes one by one
	for (int i = 0; i < m; ++i) {
		int x, y;
		sis >> x >> y;
		// remove existing beauty by lamp x
		b -= (a[x] == a[p[x]]);
		b -= c[x][a[x]];
		// update color of x
		c[p[x]][a[x]]--;
		a[x] = y;
		c[p[x]][a[x]]++;
		// add new beauty by lamp x
		b += (a[x] == a[p[x]]);
		b += c[x][a[x]];
		val << b << '\n';
	}
	return 0;
}
