#include <cstdio>
#include <algorithm>
#include <vector>
#include <iostream>
#include <cassert>

using namespace std;

const int MAXN = 300000 + 5;

int n, m, k, par[MAXN], qx[MAXN], qy[MAXN], ret, cl[MAXN];
vector<int> sc[MAXN], scnt[MAXN];

inline int cnt_color (int x, int y) {
	if (sc[x].size() == 0 || sc[x].back() < y)
		return 0;
	if (*lower_bound(sc[x].begin(), sc[x].end(), y) != y)
		return 0;
	return scnt[x][lower_bound(sc[x].begin(), sc[x].end(), y) - sc[x].begin()];
}

inline void modify (int x, int y, int z) {
	int pos = lower_bound(sc[par[x]].begin(), sc[par[x]].end(), y) - sc[par[x]].begin();
	scnt[par[x]][pos] += z;
}

int main () {
	freopen("ehesis.txt", "r", stdin);
	freopen("eheval.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> k;
/*	assert(1 <= n && n <= 300000);
	assert(1 <= m && m <= 300000);
	assert(1 <= k && k <= 1000000000);*/
	for(int i = 1; i <= n; i++) {
		cin >> cl[i];
//		assert(1 <= cl[i] && cl[i] <= k);
	}
	par[1] = -1;
	par[2] = 1;
	for(int i = 3; i <= n; i++) {
		cin >> par[i];
//		assert(1 <= par[i] && par[i] < i);
	}
	for(int i = 2; i <= n; i++)
		sc[par[i]].push_back(cl[i]);

	for(int i = 1; i <= m; i++) {
		cin >> qx[i] >> qy[i];
		if (qx[i] > 1)
			sc[par[qx[i]]].push_back(qy[i]);
	}

	for(int i = 1; i <= n; i++) {
		sort(sc[i].begin(), sc[i].end());
		unique(sc[i].begin(), sc[i].end());
		scnt[i].resize(sc[i].size());
	}

	for(int i = 2; i <= n; i++) modify (i, cl[i], 1);

	for(int i = 1; i <= n; i++)
		ret += cnt_color(i, cl[i]);

	for(int i = 1; i <= m; i++) {
//		assert(1 <= qx[i] && qx[i] <= n);
//		assert(1 <= qy[i] && qy[i] <= k);
		ret -= cnt_color(qx[i], cl[qx[i]]);
		if (qx[i] > 1 && cl[qx[i]] == cl[par[qx[i]]])
			--ret;
		if (qx[i] > 1)
			modify(qx[i], cl[qx[i]], -1);
		cl[qx[i]] = qy[i];
		if (qx[i] > 1)
			modify(qx[i], cl[qx[i]], 1);
		ret += cnt_color(qx[i], cl[qx[i]]);
		if (qx[i] > 1 && cl[qx[i]] == cl[par[qx[i]]])
			++ret;
		cout << ret << '\n';
	}

	return 0;
}
