const maxN = 300000 + 100;

var p, color, size, vertex, newColor, lastColor, lastRes, buffer : array[0 .. maxN] of longint;
    n, m, k, i, j, q, q2, newSize, answer: longint;
    cntColor, uniqueColor : array[0 .. maxN] of array of longint;
    

procedure initAdd(v : longint; color : longint);
var x : longint;
begin
 x := 10;
 size[v] := size[v] + 1;
 if (size[v] mod x = 1) then 
  begin
   setlength(uniqueColor[v], size[v] + x + 1);
   setlength(cntColor[v], size[v] + x + 1);
  end;
 uniqueColor[v][size[v]] := color;
 cntColor[v][size[v]] := 0;
end;

procedure swap(var t, y : longint);
var u : longint;
begin
 u := t; t := y; y := u;
end;

procedure sort(indVertex : longint; l : longint; r : longint);
var i, j, mid : longint;
begin
 mid := uniqueColor[indVertex][(l + r) div 2];
 i := l; j := r;
 repeat
   while (uniqueColor[indVertex][i] < mid) do i := i + 1;
   while (uniqueColor[indVertex][j] > mid) do j := j - 1;
   if (i <= j) then
    begin
     swap(uniqueColor[indVertex][i], uniqueColor[indVertex][j]);
     i := i + 1;
     j := j - 1;
    end; 
 until i > j;
 if (l < j) then sort(indVertex, l, j);
 if (i < r) then sort(indVertex, i, r);
end;

procedure FAIL();
begin
 writeln('FAIL :(');
 close(input);
 close(output);
 halt;
end;

function getIndex(v : longint; color : longint) : longint;
var left, right, middle : longint;
begin
 left := 1;
 right := size[v];
 while (right - left > 1) do
  begin
   middle := (left + right) div 2;
   if (uniqueColor[v][middle] = color) then
    begin
     getIndex := middle;
     exit;
    end;
   if (uniqueColor[v][middle] < color) then left := middle else right := middle;
  end;
 if (uniqueColor[v][left] = color) then getIndex := left else
 if (uniqueColor[v][right] = color) then getIndex := right else getIndex := -1;
end;

procedure add(v : longint; color : longint; add : longint);
var index : longint;
begin
 if lastColor[v] = color then index := lastRes[v] else
 index := getIndex(v, color);
 lastColor[v] := color;
 lastRes[v] := index;
 if (index = -1) then FAIL();
 cntColor[v][index] := cntColor[v][index] + add;
end;

function get(v, color : longint) : longint;
var index : longint;
begin
 if lastColor[v] = color then index := lastRes[v] else
 index := getIndex(v, color);
 lastColor[v] := color;
 lastRes[v] := index;
 if (index = -1) then FAIL();
 get := cntColor[v][index]; 
end;

procedure union(num : longint; l1, r1, l2, r2 : longint);
var i, j, cnt : longint;
begin
 i := l1;
 j := l2;
 cnt := 0;
 while (i <= r1) and (j <= r2) do
  begin
   if (uniqueColor[num][i] < uniqueColor[num][j]) then 
    begin
     cnt := cnt + 1;
     buffer[cnt] := uniqueColor[num][i];
     i := i + 1;
    end else
    begin
     cnt := cnt + 1;
     buffer[cnt] := uniqueColor[num][j];
     j := j + 1;
    end;
  end;
 while (i <= r1) do
  begin
   cnt := cnt + 1;
   buffer[cnt] := uniqueColor[num][i];
   i := i + 1;
  end;
 while (j <= r2) do
  begin
   cnt := cnt + 1;
   buffer[cnt] := uniqueColor[num][j];
   j := j + 1;
  end;
 for i := l1 to r2 do uniqueColor[num][i] := buffer[i - l1 + 1];
end;

procedure mergeSort(num : longint; l, r : longint);
var mid, i, j: longint;
begin
 if (l = r) then exit;
 if (r - l < 5) then
	begin
	 for i := l + 1 to r do
	  begin
	   j := i;
	   while (j - 1 >= l) and (uniqueColor[num][j] < uniqueColor[num][j - 1]) do
	    begin
	     swap(uniqueColor[num][j], uniqueColor[num][j - 1]);
	     j := j - 1;
	    end;
	  end; 
	end else
	begin
	 mid := (l + r) div 2;
	 mergeSort(num, l, mid);
	 mergeSort(num, mid + 1, r);
	 union(num, l, mid, mid + 1, r);
	end;
end;

begin
 assign(input, 'ehesis.txt'); reset(input);
 assign(output, 'eheval.txt'); rewrite(output);
 readln(n, m, k);
 for i := 1 to n do read(color[i]);
 for i := 3 to n do
  read(p[i]);
 for i := 1 to m do read(vertex[i], newColor[i]);
 p[2] := 1;
 p[1] := -1;
 for i := 1 to n do size[i] := 0;
 for i := 1 to n do initAdd(i, color[i]);
 for i := 2 to n do initAdd(p[i], color[i]);
 for i := 1 to m do
  begin
   initAdd(vertex[i], newColor[i]);
   if (vertex[i] <> 1) then initAdd(p[vertex[i]], newColor[i]);
  end;
 for i := 1 to n do
  mergeSort(i, 1, size[i]);    
 for i := 1 to n do
  begin
   newSize := 1;
   for j := 2 to size[i] do
    if (uniqueColor[i][j] = uniqueColor[i][newSize]) then continue else
     begin
      newSize := newSize + 1;
      uniqueColor[i][newSize] := uniqueColor[i][j];
     end;
   size[i] := newSize;
  end;                                                            
 answer := 0;
 for i := 2 to n do
  if color[i] = color[p[i]] then answer := answer + 1;
 for i := 2 to n do add(p[i], color[i], 1);
 for i := 1 to m do
  begin
   answer := answer - get(vertex[i], color[vertex[i]]);
   answer := answer + get(vertex[i], newColor[i]);
   if (vertex[i] <> 1) then
    begin
     if (color[p[vertex[i]]] = color[vertex[i]]) then answer := answer - 1;
     if (color[p[vertex[i]]] = newColor[i]) then answer := answer + 1;
    end; 
   if (vertex[i] <> 1) then
    begin
     add(p[vertex[i]], color[vertex[i]], -1);
     add(p[vertex[i]], newColor[i], 1);
    end;
   color[vertex[i]] := newColor[i];
   writeln(answer);
  end;
 close(input);
 close(output);
end.