// This is the grader used for evaluation on the server

#include "pal.h"
#include <cstdio>

static int bits(int m) {
	m = (m & 0x55555555) + ((m >> 1) & 0x55555555);
	m = (m & 0x33333333) + ((m >> 2) & 0x33333333);
	m = (m & 0x0f0f0f0f) + ((m >> 4) & 0x0f0f0f0f);
	m = (m & 0x00ff00ff) + ((m >> 8) & 0x00ff00ff);
	m = (m & 0x0000ffff) + ((m >> 16) & 0x0000ffff);
	return m;
}

int main() {
	FILE *sis = fopen("palsis.txt", "rt");
	if (!sis) {
		perror("palsis.txt");
		return 0;
	}
	FILE *val = fopen("palval.txt", "wt");
	if (!val) {
		perror("palval.txt");
		return 0;
	}

	int k, n;
	fscanf(sis, "%d%d", &k, &n);
	init(k, n);
	bool pal[1 << k];
	for (int i = 0; i < (1 << k); ++i) {
		pal[i] = false;
	}
	int s = 0;
	for (int i = 0; i < n; ++i) {
		int t, c;
		fscanf(sis, "%d%d", &t, &c);
		if (t == 1) {
			add(c);
			pal[c] = true;
		}
		if (t == 2) {
			int r = find(c);
			if (r < 0 || r >= (1 << k) || !pal[r]) {
				// contestant returned color not in palette
				fprintf(val, "%d\n", -1);
				return 0;
			}
			// similarity of contestant's response to the request
			s += k - bits(r ^ c);
		}
	}
	done();
	fprintf(val, "%d\n", s);
	return 0;
}
