#include "pal.h"

const int INF = 1000000000;
const int MAXN = 1 << 20;

int dist[MAXN];
int best[MAXN];
int q[MAXN], q1, q2;
int K;

void init(int k, int n) {
	for(int i = 0; i < (1 << k); i++) {
		dist[i] = INF;
	}
	K = k;
}

void add(int c) {
	if (dist[c] == 0) {
		return;
	}
	q1 = q2 = 0;
	q[q1++] = c;
	dist[c] = 0;
	best[c] = c;
	while (q1 != q2) {
		int vn = q[q2++];
		for (int j = 0; j < K; j++) {
			if (dist[vn ^ (1 << j)] > dist[vn] + 1) {
				q[q1++] = vn ^ (1 << j);
				dist[vn ^ (1 << j)] = dist[vn] + 1;
				best[vn ^ (1 << j)] = c;
			}
		}
	}
}

int find(int c) {
	return best[c];
}

void done() {
}
